// #Autoload
// #name = Recording Options
// #version = 1.6
// #date = 31 Jan 2003
// #status = Release
// #author = @-Kaiten Commander
// #warrior = Kaiten Commander
// #email = kaiten@cb-tribes.co.uk
// #web = http://www.kaiten.barrysworld.net
// #description = Demo Reminder in Tournament Mode. Still a posibiltiy of Corrupt demos.
// #description = Includes options to save to Mod dir & Map dir.
// #description = New Recordings Browser which supports sub dirs.
// #credits = ilys for trans demo status hud, recordings dialog popup bind, intergrated demo search, demo auto-naming and minor bug fixes.
// #readme = scripts/kaiten/FullRecordings.txt
// #include = support/mission_callbacks.cs
// #include = support/date_support.cs
// #include = support/team_tracker.cs
// #include = scripts/kaiten/PJStrings.cs
// #category = ilys' Scripts
//======================================================================================================

if( !isObject(DemoReminder) )
{
	new ScriptObject(DemoReminder)
	{
		on = 0;
	};
}

if(isfile("prefs/DemoReminderPrefs.cs")) exec("prefs/DemoReminderPrefs.cs");

package KmaDemoReminderLoad
{
	function clientCmdPickTeamMenu( %teamA, %teamB )
	{
		DemoReminder.on = 1;
		parent::clientCmdPickTeamMenu( %teamA, %teamB );
	}

	function defaultMessageCallback(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10)
	{
		parent::defaultMessageCallback(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
		if( DemoReminder.on && !isPlayingDemo() && !isRecordingDemo())
		{
			if((strstr(%msgString, "You joined") != -1) && $DemoPref::StartOnJoinTeam) schedule(3000, 0, startRecordingDemo, true);
			if((StrStr(%msgString, "Match started") != -1) && $DemoPref::StartOnMatchStart) schedule(1000, 0, startRecordingDemo, true);
			if((StrStr(%msgString, "Match started") != -1) && !$DemoPref::StartOnMatchStart)
			{
				if($KmaDemoReminderSchedule !$= "") cancel($KmaDemoReminderSchedule);
				KmaDemoReminderHUD.visible = 0;
		 		$NewMap = 1;
				schedule(5000, 0, DemoReminderWakeup);
			}
		}
		else if(!isPlayingDemo() && isRecordingDemo())
		{
			if((StrStr(%msgString, "Match has ended") != -1) && $DemoPref::AutoStopOnEnd) schedule(2000, 0, stopRecordingDemo, true);
		}
	}

	function OptionsDlg::onWake( %this )
	{
		if ( $KmaDemoReminderLoaded $= "false" )
		{
			$RemapName[$RemapCount] = "KmA Demo Reminder";
			$RemapCmd[$RemapCount] = "KmaDemoToggle";
			$RemapCount++;
			$RemapName[$RemapCount] = "KmA Toggle Dialog";
			$RemapCmd[$RemapCount] = "KmaDialogToggle";
			$RemapCount++;
			$KmaDemoReminderLoaded = "true";
		}
		parent::onWake( %this );
	}

	function PlayGui::onWake( %this )
	{
		if ($KmaDemoCallBack $= "false")
		{
			addMessageCallback('MsgMissionStart', KmaDemoCheck);
			addMessageCallback('MsgAdminForce', KmaDemoReminderOff);
			addMessageCallback('MsgVotePassed', KmaDemoReminderOff);
			$KmaDemoCallBack = "true";
		}
		parent::onWake( %this );
		if(!isRecordingDemo()) DemoStatusHudUpdate("OFF");
    		else DemoStatusHudUpdate("ON");
		DemoStatusHud.setVisible($DemoPref::ShowStatusHud);
	}

	function clientCmdTogglePlayHuds(%val)
	{
		parent::clientCmdTogglePlayHuds(%val);
		if($DemoPref::ShowStatusHud) DemoStatusHud.setVisible(%val);
	}

	function startRecordingDemo( %val )
	{
        	%Demo = "ON";
        	DemoStatusHudUpdate(%Demo);
        	parent::startRecordingDemo( %val );
	}

	function stopRecordingDemo( %val )
	{
        	%Demo = "OFF";
        	DemoStatusHudUpdate(%Demo);
        	parent::stopRecordingDemo( %val );
	}
};
activatePackage(KmaDemoReminderLoad);
$KmaDemoReminderLoaded = "false";
$KmaDemoCallback = "false";
$KmaDemoToggle = 1;
$KmaDialogToggle = 0;

function KmaDemoReminder()
{
 	if (!$KmaDemoToggle) return;
 	if ($NewMap) %time = 0;
 	$NewMap = 0;
	KmaDemoFlash();
	$KmaDemoReminderSchedule = schedule((%time += 250), 0, KmaDemoReminder);
}

function KmaDemoFlash()
{
	if (!$KmaDemoToggle) return;
	KmaDemoReminderHUD.visible = !KmaDemoReminderHUD.visible;
	alxPlay(sButtonOver, 0, 0, 0);
}

function KmaDemoToggle(%val)
{
	if(%val)
	{
		$KmaDemoToggle = !$KmaDemoToggle;
		if($KmaDemoToggle) addMessageHudLine("\c2Demo Reminder is now: ON.");
		else addMessageHudLine("\c2Demo Reminder is now: OFF.");
	}
}

function KmaDialogToggle(%val)
{
	if(%val)
	{
		$KmaDialogToggle = !$KmaDialogToggle;
		if($KmaDialogToggle)
		{
			Canvas.pushDialog(FullRecordingsDlg);
			Canvas.popDialog(LaunchToolbarDlg);
		}
		else Canvas.popDialog(FullRecordingsDlg);
	}
}

function KmaDemoCheck(%msgType, %msgString, %time)
{
	if( DemoReminder.on && !isPlayingDemo() && !isRecordingDemo() && (strstr(%msgString, "Match starts in") != -1 && %time $= $DemoPref::AnnounceTime) )
	{
		if($DemoPref::Announce) commandToServer('teamMessageSent', "\c5"@$DemoPref::TeamMessage);
		if(!$DemoPref::StartOnMatchStart) KmaDemoReminder();
	}
}

function DemoTimePopup::onSelect(%this, %id, %text)
{
	$DemoPref::AnnounceTime = %text;
	$DemoPref::AnnounceId = %id;
}

function DemoReminderSavePrefs()
{
	export("$DemoPref::*", "prefs/DemoReminderPrefs.cs", false);
	exec("prefs/DemoReminderPrefs.cs");
}

function DemoStatusHudUpdate(%Demo)
{
	DemoStatusHudtext.setValue(%Demo);
}

function DemoReminderWakeup()
{
	if(!isRecordingDemo())
	{
		alxPlay(InputDeniedSound, 0, 0, 0);
		AddmessageHudline("\c0You are \c5Not\c0 Recording!!");
	}
}

function GetTeamTags(%getteamID)
{
	$bestTag[1] = "";
	$bestTag[2] = "";
	commandToServer('getScores');
	%count = PlayerListGroup.getCount();
	for(%i = 0; %i < %count; %i++)
	{
		%obj = PlayerListGroup.getObject(%i);
		if ( !%obj.isSmurf )
		{
			%name = %obj.name;
			%teamid = %obj.teamId;
			%pos1 = strStr(%name, "\c6");
			if(%pos1 > 0)
			{
				%pos2 = strStr(%name, "\c7");
				if(%pos2 < %pos1)
				{
					%Tag = getSubStr(%name, %pos2 + 1, %pos1 - %pos2 - 1);
				}
				else
				{
					%pos3 = strStr(%name, "\x11");
					%Tag = getSubStr(%name, %pos2 + 1, %pos3 - %pos2 - 1);
				}
			}
			if ( %Tag !$= "" )
			{
 				%tagCounts[%teamid, %Tag]++;
				if ( %tagCounts[%teamid, %Tag] > %bestTagCount[%teamid] )
				{
  					%bestTagCount[%teamid] = %tagCounts[%teamid, %Tag];
  					$bestTag[%teamid] = %Tag;
				}
			}
		}
	}
	return $bestTag[%getteamID];
}

function OpenDemoNamePrompt()
{
	DemoNameOKBtn.command = "DemoReminderSavePrefs(); Canvas.popDialog(DemoNameDlg); CloseDemoNamePrompt();";
	if($DemoPref::DemoNamePromptStart) Canvas.pushDialog(DemoNameDlg);
	else CloseDemoNamePrompt();
}

function CloseDemoNamePrompt()
{
	DemoNameOKBtn.command = "DemoReminderSavePrefs(); Canvas.popDialog(DemoNameDlg);";
	%mod = MissionCallback.getServerMod();
	if(%mod $= "")
	{
		%grav = getState(Gravity);
		switch$(%grav)
		{
			case "-26.9":
				%mod = "Classic";
			case "-43":
				%mod = "TR2";
			case "-20":
				%mod = "Base";
			default:
				%mod = "Base-Unk";
		}
	}
	%mission = PJStripInvalid(StripNameColors(MissionCallback.getMissionName()));
	%gametype = PJStripInvalid(StripNameColors(MissionCallback.getMissionType()));
	%server = PJStripInvalid(StripNameColors(MissionCallback.getServerName()));
	%address = PJStripInvalid(StripNameColors(MissionCallback.getServerAddress()));
	%player = PJStripInvalid(StripNameColors(teamTracker.myName));
	%team1side = PJStripInvalid(StripNameColors(teamtracker.getFriendlyTeamName()));
	%team2side = PJStripInvalid(StripNameColors(teamtracker.getEnemyTeamName()));
	%team1tag = PJStripInvalid(StripNameColors(GetTeamTags(teamtracker.friendlyTeamID)));
	%team2tag = PJStripInvalid(StripNameColors(GetTeamTags(teamtracker.enemyTeamID)));
	%teamsize = PJStripInvalid(StripNameColors(teamtracker.getTeamSize(1,true)));
	%day = PJStripInvalid(StripNameColors(formatTimeString("dd")));
	%month = PJStripInvalid(StripNameColors(formatTimeString("mm")));
	%year = PJStripInvalid(StripNameColors(formatTimeString("yy")));
	for(%i = 0; %i < 1000; %i++)
	{
		%num = %i;
		if(%num < 10) %num = "0" @ %num;
		if(%num < 100) %num = "0" @ %num;
		demonamestring.setValue($DemoPref::DemoName);
		%name = demonamestring.getValue();
		if(strStr(%name, "*mod*") !=-1) %name = strReplace(%name, "*mod*", %mod);
		if(strStr(%name, "*map*") !=-1) %name = strReplace(%name, "*map*", %mission);
		if(strStr(%name, "*gt*") !=-1) %name = strReplace(%name, "*gt*", %gametype);
		if(strStr(%name, "*ser*") !=-1) %name = strReplace(%name, "*ser*", %server);
		if(strStr(%name, "*ip*") !=-1) %name = strReplace(%name, "*ip*", %address);
		if(strStr(%name, "*pl*") !=-1) %name = strReplace(%name, "*pl*", %player);
		if(strStr(%name, "*t1s*") !=-1) %name = strReplace(%name, "*t1s*", %team1side);
		if(strStr(%name, "*t2s*") !=-1) %name = strReplace(%name, "*t2s*", %team2side);
		if(strStr(%name, "*t1t*") !=-1) %name = strReplace(%name, "*t1t*", %team1tag);
		if(strStr(%name, "*t2t*") !=-1) %name = strReplace(%name, "*t2t*", %team2tag);
		if(strStr(%name, "*ts*") !=-1) %name = strReplace(%name, "*ts*", %teamsize);
		if(strStr(%name, "*day*") !=-1) %name = strReplace(%name, "*day*", %day);
		if(strStr(%name, "*month*") !=-1) %name = strReplace(%name, "*month*", %month);
		if(strStr(%name, "*year*") !=-1) %name = strReplace(%name, "*year*", %year);
		if(demonamestring.getValue() $= "") %name = "demo";
		%file = "recordings/"@%name@%num@".rec";
		if(!isfile(%file)) break;
	}
	if(%i == 1000) return;
	$DemoFile = %file;
	addMessageHudLine( "\c4Recording to file [\c2" @ $DemoFile @ "\cr].");
	saveDemoSettings();
	startRecord(%file);
	if(!isRecordingDemo())
	{
		deleteFile("recordings/" @ $DemoFile @ ".rec");
		addMessageHudLine( "\c3 *** Failed to record to file [\c2" @ $DemoFile @ "\cr].");
		$DemoFile = "";
	}
}

function beginDemoRecord()
{
	stopDemoRecord();
	if($KmaDemoReminderSchedule !$= "") cancel($KmaDemoReminderSchedule);
	KmaDemoReminderHUD.visible = 0;
	$NewMap = 1;
	OpenDemoNamePrompt();
}

function demoRecordComplete()
{
   if($DemoFile !$= "")
   {
      addMessageHudLine( "\c4Stopped recording to file [\c2" @ $DemoFile @ "\cr].");
      $DemoFile = "";
   }
}

function KmaDemoReminderOff(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10)
{
	if( strstr(%msgString, "Free For All") != -1 )
	{
		if($KmaDemoReminderSchedule !$= "") cancel($KmaDemoReminderSchedule);
		KmaDemoReminderHUD.visible = 0;
 		$NewMap = 1;
		DemoReminder.on = 0;
		schedule(2000, 0, stopRecordingDemo, true);
	}
}

function RecordingsDlg::onWake(%this)
{
	Canvas.popDialog(RecordingsDlg);
	LaunchADVRECBrowser();
}

function LaunchADVRECBrowser()
{
    LaunchTabView.viewTab( "RECORDINGS", FullRecordingsDlg, 0 );
}

function FullRecordingsDlg::onWake(%gui)
{
	%gui.fillRecordingsList();
	updateRecordingButtons();
	%selId = $DemoPref::AnnounceId;
	DemoTimePopup.setSelected(%selId);
	Canvas.pushDialog(LaunchToolbarDlg);
}

function DemoNameDlg::onWake(%this)
{
	if($DemoPref::Scheme !$= "") demonametitle.settext("Demo Naming Scheme - "@$DemoPref::Scheme);
	else demonametitle.settext("Demo Naming Scheme");
	demonamestring.setValue($DemoPref::DemoName);
}

function msToMinSec(%time)
{
	%sec = mFloor(%time / 1000);
	%min = mFloor(%sec / 60);
	%sec -= %min * 60;
	if(%min < 10) %min = "0" @ %min;
	if(%sec < 10) %sec = "0" @ %sec;
	return(%min @ ":" @ %sec);
}

function FullRecordingsDlg::fillRecordingsList(%gui)
{
	if(!%gui.initialized)
	{
		FullRecordingsDlgList.setSortColumn(0);
		FullRecordingsDlgList.setSortIncreasing(true);
		FullRecordingsDlgList.addStyle(1, $ShellFont, $ShellFontSize, "80 220 200", "30 255 225", "10 60 40" );
		FullRecordingsDlgList.addStyle(2, $ShellFont, $ShellFontSize, "120 120 120", "120 120 120", "120 120 120" );
		FullRecordingsDlgList.addColumn(0, "Time", 140, 140, 200, "filetime center");
		FullRecordingsDlgList.addColumn(1, "Length (min:sec)", 80, 80, 80, "center");
 		FullRecordingsDlgList.addColumn(2, "Recording", 400, 250, 800);
		FullRecordingsDlgList.addColumn(3, "Folder", 200, 100, 300, "left");
		%gui.initialized = true;
	}
	FullRecordingsDlgList.clear();
	FullRecordingsDlgList.clearList();
	%searchstr = searchstring.getValue();
	%search = "recordings/*.rec";
	%ct = 0; %folderct = 0;
	%demoVersion = getDemoVersion();
	rebuildModPaths();
	for(%file = findFirstFile(%search); %file !$= ""; %file = findNextFile(%search))
	{
		%fileName = fileBase(%file);
		%filePath = filePath(%file) @ "/";
		if(!(%folders[%folderct] $= %filePath))
		{
      			%folders[%folderct + 1] = %filePath;
      			%folderct++;
      		}
      		%val = getDemoVersionLength(%file);
      		%version = getField(%val, 0);
      		if(%version == -1)
      		{
         		%version = "???";
         		%length = "???";
      		}
      		else %length = msToMinSec(getField(%val, 1));
      		%filedate = date("m/d/Y", convertTime(getFileModifyTime(%file)));
		if(strstr(%fileName, %SearchStr) !=-1 && $DemoPref::SearchName == 1 || strstr(%length, %SearchStr) !=-1 && $DemoPref::SearchLength == 1 || strstr(%filedate, %SearchStr) !=-1 && $DemoPref::SearchDate == 1 || strstr(%filePath, %SearchStr) !=-1 && $DemoPref::SearchFolder == 1 || %searchstr $= "")
		{
			%fileTime = getFileModifyTime(%file);
			FullRecordingsDlgList.addRow(%ct, %fileTime TAB %length TAB %fileName TAB %filePath);
			FullRecordingsDlgList.setRowStyle(%ct, (%version == %demoVersion) ? 1 : 2);
			%ct++;
	      	}
   	}
   	FullRecordingsDlgList.sort(0, false);
   	FullRecordingsDlgList.setSelectedRow(0);
	DemoRecordingsDlgPane.setText("SELECT RECORDING - "@%ct@" Found");
	if(%ct == 0)
	{
		MessageBoxOK( "NOT FOUND", "No demos with \"" @ %SearchStr @ "\" in their name, length or date were found." );
		alxPlay( InputDeniedSound, 0, 0, 0 );
	}	
}

function updateRecordingButtons()
{
	%active = FullRecordingsDlgList.rowCount() != 0;
	if(isRecordingDemo() || isPlayingDemo() || Canvas.getContent().getName() $= "PlayGui") Full_StartDemoBtn.setActive(0);
	else Full_StartDemoBtn.setActive(%active);
   	Full_DeleteDemoBtn.setActive(%active);
   	Full_RenameDemoBtn.setActive(%active);
   	if(%active) Full_SearchDemoBtn.makeFirstResponder(1);
}


function StartSelectedDemo()
{
	%demoinfo = FullRecordingsDlg.GetDemoInfo();
	%sel = getField(%demoinfo, 0);
	%time = getField(%demoinfo, 1);
	%length = getField(%demoinfo, 2);
	%file = getField(%demoinfo, 3);
	%path = getField(%demoinfo, 4);
   	%fq_file = %path @ %file @ ".rec";
   	%verLen = getDemoVersionLength(%fq_file);
   	Canvas.pushDialog(DemoLoadProgressDlg);
   	if(playDemo(%fq_file) || !isRecordingDemo() || !isPlayingDemo() || Canvas.getContent().getName() !$= "PlayGui")
   	{
      		alxEnableForceFeedback(false);
      		resetGameState();
      		Canvas.popDialog(DemoLoadProgressDlg);
      		Canvas.popDialog(FullRecordingsDlg);
      		Canvas.setContent(PlayGui);
      		loadDemoSettings();
      		$DemoPlaybackIndex = 5;
      		$DemoPlaybackLastIndex = 5;
      		GlobalActionMap.bindCmd(keyboard, "escape", "", "stopDemoPlayback();");
      		GlobalActionMap.bindCmd(keyboard, "tab", "", "toggleDemoPlaybackHud();");
      		GlobalActionMap.bindCmd(keyboard, "space", "", "toggleDemoPause();");
      		GlobalActionMap.bindCmd(keyboard, "numpadadd", "", "stepDemoPlaybackSpeed(1);");
      		GlobalActionMap.bindCmd(keyboard, "numpadminus", "", "stepDemoPlaybackSpeed(-1);");
		$globalActionMapOnly = false;
      		$DemoPlaybackProgress = 0;
      		$DemoPlaybackLength = getField(%verLen, 1);
      		if($DemoPlaybackLength == 0) $DemoPlaybackLength = 60000;
      		DemoPlayback_EndTime.setValue(msToMinSec($DemoPlaybackLength));
      		$DemoPlaybackIndex = 5;
      		$DemoPlaybackLastIndex = 5;
      		$DemoPlaybackProgress = 0;
      		demoPlaybackUpdate(0);
      		updateDemoPlaybackStatus();
   	}
   	else MessageBoxOK("Playback Failed", "Demo playback failed for file '" @ %fq_file @ "'.");
   	Canvas.popDialog(DemoLoadProgressDlg);
}

function demoPlaybackComplete()
{
	alxStopAll();
   	alxEnableForceFeedback(true);
   	if(DemoPlaybackDlg.isAwake()) Canvas.popDialog(DemoPlaybackDlg);
   	Canvas.setContent("LaunchGui");
   	Canvas.pushDialog(FullRecordingsDlg);
   	resetGameState();
   	purgeResources();
   	GlobalActionMap.unbind(keyboard, escape);
   	GlobalActionMap.unbind(keyboard, tab);
   	GlobalActionMap.unbind(keyboard, space);
   	GlobalActionMap.unbind(keyboard, numpadadd);
   	GlobalActionMap.unbind(keyboard, numpadminus);
   	$globalActionMapOnly = false;
}

function doRecordingDelete(%path,%file)
{
   	if(deleteFile(%path @ %file @ ".rec"))
   	{
      		FullRecordingsDlg.fillRecordingsList();
      		FullRecordingsDlg.updateRecordingButtons();
   	}
   	else messageBoxOK("Failed", "Failed to remove file '" @ %file @ "'.");
}

function DeleteSelectedDemo()
{
	%demoinfo = FullRecordingsDlg.GetDemoInfo();
	%sel = getField(%demoinfo, 0);
	%time = getField(%demoinfo, 1);
	%length = getField(%demoinfo, 2);
	%file = getField(%demoinfo, 3);
	%path = getField(%demoinfo, 4);
   	messageBoxOkCancel("Delete Recording?", "Are you sure you wish to delete recording file '" @ %file @ "'?", "doRecordingDelete(\"" @ %path @ "\",\"" @ %file @ "\");");
}

function doDemoFileRename()
{
   	%sel = FullRecordingsDlgList.getSelectedId();
   	%file = getField(FullRecordingsDlgList.getRowTextById(%sel), 2);
	%demoinfo = FullRecordingsDlg.GetDemoInfo();
	%sel = getField(%demoinfo, 0);
	%time = getField(%demoinfo, 1);
	%length = getField(%demoinfo, 2);
	%file = getField(%demoinfo, 3);
	%path = getField(%demoinfo, 4);
   	%newFile = DemoRenameFile_Edit.getValue();
   	if(%file $= %newFile) return;
   	if(%newFile !$= "")
   	{
      		if(renameFile(%path @ %file @ ".rec", %path @ %newFile @ ".rec"))
      		{
         		rebuildModPaths();
         		FullRecordingsDlg.fillRecordingsList();
       			return;
      		}
   	}
   	MessageBoxOK("Rename Failed", "Failed to rename file '" @ %file @ "' to '" @ %newFile @ "'.");
}

function RenameSelectedDemo()
{
	%demoinfo = FullRecordingsDlg.GetDemoInfo();
	%sel = getField(%demoinfo, 0);
	%time = getField(%demoinfo, 1);
	%length = getField(%demoinfo, 2);
	%file = getField(%demoinfo, 3);
	%path = getField(%demoinfo, 4);
   	DemoRenameFile_Edit.setValue(%file);
   	Canvas.pushDialog(DemoRenameFileDlg);
}

function FullRecordingsDlg::GetDemoInfo()
{
	%sel = FullRecordingsDlgList.getSelectedId();
   	%row = %sel TAB FullRecordingsDlgList.getRowTextById(%sel);
}

function LoadScheme(%file)
{
	%SchemeLoad = new FileObject();
	%SchemeLoad.openForRead("prefs/"@%file@".sch");
	%temp = %SchemeLoad.readLine();
	%SchemeLoad.close();
	%SchemeLoad.delete();
	$DemoPref::DemoName = %temp;
	demonamestring.setValue($DemoPref::DemoName);
	$DemoPref::Scheme = %file;
	demonametitle.settext("Demo Naming Scheme - "@$DemoPref::Scheme);
	DemoReminderSavePrefs();
}

function SaveScheme(%file)
{
	%SchemeSave = new FileObject();
	%SchemeSave.openForWrite("prefs/"@%file@".sch");
	%SchemeSave.writeLine(demonamestring.getValue());
	%SchemeSave.close();
	%SchemeSave.delete();
	$DemoPref::Scheme = %file;
	demonametitle.settext("Demo Naming Scheme - "@$DemoPref::Scheme);
	DemoReminderSavePrefs();
}

function DeleteScheme(%file)
{
	if(deleteFile("prefs/"@%file@".sch"))
	{
		demonametitle.settext("Demo Naming Scheme");
		demonamestring.setValue("");
		$DemoPref::Scheme = "";
		$DemoPref::DemoName = "";
	}
	else messageBoxOK("Failed", "Failed to remove file '" @ %file @ "'.");
}

if(!isObject(FullRecordingsDlg))
{
        new GuiChunkedBitmapCtrl(FullRecordingsDlg) {
        	profile = "GuiContentProfile";
        	horizSizing = "width";
        	vertSizing = "height";
        	position = "0 0";
        	extent = "640 480";
        	minExtent = "8 8";
        	visible = "1";
            	hideCursor = "0";
            	bypassHideCursor = "0";
        	variable = "$ShellBackground";
        	helpTag = "0";
        	useVariable = "1";
        	new ShellPaneCtrl(DemoRecordingsDlgPane)
        	{
        		profile = "ShellDlgPaneProfile";
        		horizSizing = "width";
        		vertSizing = "height";
        		position = GM_Frame.position;
        		extent = GM_Frame.extent;
        		minExtent = "48 92";
        		visible = "1";
        		hideCursor = "0";
        		bypassHideCursor = "0";
        		helpTag = "0";
        		text = "SELECT RECORDING - 0 Found";
        		longTextBuffer = "0";
        		maxLength = "255";
        		noTitleBar = "0";
        		new ShellFancyArrayScrollCtrl()
        		{
        			profile = "NewScrollCtrlProfile";
        			horizSizing = "width";
        			vertSizing = "height";
        			position = "23 37";
        			extent = "580 266";
        			minExtent = "32 32";
        			visible = "1";
        			hideCursor = "0";
        			bypassHideCursor = "0";
        			helpTag = "0";
        			fixedHorizontal = "1";
        			vertSpacerBitmap = "gui/shll_vertspacer";
        			horzSpacerBitmap = "gui/shll_horzspacer";

        			new ShellFancyTextList(FullRecordingsDlgList)
        			{
        				profile = "ShellServerBrowserProfile";
        				horizSizing = "right";
        				vertSizing = "bottom";
        				position = "0 0";
        				extent = "560 262";
        				minExtent = "8 20";
        				visible = "1";
        				hideCursor = "0";
        				bypassHideCursor = "0";
        				helpTag = "0";
        				startScrollRegion = "3 0";
        				headerBitmap = "gui/server_tabs";
        				sortArrowBitmap = "gui/shll_sortarrow";
        				fieldBase = "gui/shll_field";
        				barBase = "gui/shll_bar";
        				glowOffset = "4";
        				rowHeight = "19";
        				headerFontType = "Univers Condensed";
        				headerFontSize = "16";
        				headerFontColor = "8 19 6 255";
        				headerFontColorHL = "25 68 56 255";
        				separatorColor = "192 192 192 255";
        				drawSeparators = "0";
        				headerSort = "1";
        				allowReposition = "1";
        				noSelect = "0";
        				allowColorChars = "1";
        		            	altCommand = "startSelectedDemo();";
        			};
        		};
			new ShellBitmapButton(Full_SearchDemoBtn) {
				profile = "ShellButtonProfile";
				horizSizing = "right";
				vertSizing = "top";
	       			position = "16 304";
				extent = "128 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "Canvas.pushDialog(DemoFindDlg);";
				helpTag = "0";
				text = "SEARCH";
				simpleStyle = "0";
			};
        		new ShellBitmapButton(Full_StartDemoBtn)
        		{
        			profile = "ShellButtonProfile";
        			horizSizing = "right";
        			vertSizing = "top";
        			position = "132 304";
        			extent = "128 38";
        			minExtent = "32 38";
        			visible = "1";
        			hideCursor = "0";
        			bypassHideCursor = "0";
        			command = "StartSelectedDemo();";
        			helpTag = "0";
        			text = "PLAY";
        			simpleStyle = "0";
        		};
        		new ShellBitmapButton(Full_DeleteDemoBtn)
        		{
        			profile = "ShellButtonProfile";
        			horizSizing = "right";
        			vertSizing = "top";
        			position = "248 304";
        			extent = "128 38";
        			minExtent = "32 38";
        			visible = "1";
        			hideCursor = "0";
        			bypassHideCursor = "0";
        			command = "DeleteSelectedDemo();";
        			helpTag = "0";
        			text = "DELETE";
        			simpleStyle = "0";
        		};
        		new ShellBitmapButton(Full_RenameDemoBtn)
        		{
        			profile = "ShellButtonProfile";
        			horizSizing = "right";
        			vertSizing = "top";
        			position = "364 304";
        			extent = "128 38";
        			minExtent = "32 38";
        			visible = "1";
        			hideCursor = "0";
        			bypassHideCursor = "0";
        			command = "RenameSelectedDemo();";
        			helpTag = "0";
        			text = "RENAME";
        			simpleStyle = "0";
        		};
        		new ShellBitmapButton(Full_DemoNameBtn)
        		{
        			profile = "ShellButtonProfile";
        			horizSizing = "right";
        			vertSizing = "top";
        			position = "479 304";
        			extent = "128 38";
        			minExtent = "32 38";
        			visible = "1";
        			hideCursor = "0";
        			bypassHideCursor = "0";
        			command = "Canvas.pushDialog(DemoNameDlg);";
        			helpTag = "0";
        			text = "SCHEME";
        			simpleStyle = "0";
        		};
        		new ShellToggleButton(DemoAnnounce) {
        			profile = "ShellRadioProfile";
        			horizSizing = "right";
        			vertSizing = "top";
        			position = "370 340";
        			extent = "115 36";
        			minExtent = "26 27";
        			visible = "1";
        			hideCursor = "0";
        			bypassHideCursor = "0";
        			variable = "$DemoPref::Announce";
				command = "DemoReminderSavePrefs();";
        			helpTag = "0";
        			text = "Announce to Team";
        			longTextBuffer = "0";
        			maxLength = "255";
        		};
        		new ShellToggleButton(DemoNamePrompt) {
        			profile = "ShellRadioProfile";
        			horizSizing = "right";
        			vertSizing = "top";
        			position = "485 340";
        			extent = "115 36";
        			minExtent = "26 27";
        			visible = "1";
        			hideCursor = "0";
        			bypassHideCursor = "0";
        			variable = "$DemoPref::DemoNamePromptStart";
				command = "DemoReminderSavePrefs();";
        			helpTag = "0";
        			text = "Prompt Demo Name";
        			longTextBuffer = "0";
        			maxLength = "255";
        		};
        		new ShellTextEditCtrl(TeamMessage) {
        			profile = "NewTextEditProfile";
        			horizSizing = "right";
        			vertSizing = "top";
        			position = "17 336";
        			extent = "240 38";
        			minExtent = "32 38";
        			visible = "1";
        			hideCursor = "0";
        			bypassHideCursor = "0";
        			variable = "$DemoPref::TeamMessage";
				command = "DemoReminderSavePrefs();";
        			helpTag = "0";
        			longTextBuffer = "0";
        			maxLength = "255";
        			historySize = "0";
        			password = "0";
        			IRCName = "0";
        			tabComplete = "0";
        			deniedSound = "InputDeniedSound";
        			glowOffset = "9 9";
        		};
        		new ShellPopupMenu(DemoTimePopup) {
        			profile = "ShellPopupProfile";
        			horizSizing = "right";
        			vertSizing = "top";
        			position = "250 335";
        			extent = "128 36";
        			minExtent = "49 36";
        			visible = "1";
        			hideCursor = "0";
        			bypassHideCursor = "0";
				command = "DemoReminderSavePrefs();";
        			helpTag = "0";
        			longTextBuffer = "0";
        			maxLength = "255";
        			maxPopupHeight = "200";
        			buttonBitmap = "gui/shll_pulldown";
        			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
        			selectedBarBitmap = "gui/shll_pulldownbar_act";
        			noButtonStyle = "0";
        		};
        		new ShellToggleButton(StartOnJoinTeam) {
        			profile = "ShellRadioProfile";
        			horizSizing = "right";
        			vertSizing = "top";
        			position = "20 370";
        			extent = "115 36";
        			minExtent = "26 27";
        			visible = "1";
        			hideCursor = "0";
        			bypassHideCursor = "0";
        			variable = "$DemoPref::StartOnJoinTeam";
				command = "DemoReminderSavePrefs();";
        			helpTag = "0";
        			text = "On Join Team";
        			longTextBuffer = "0";
        			maxLength = "255";
        		};
        		new ShellToggleButton(StartOnMatchStart) {
        			profile = "ShellRadioProfile";
        			horizSizing = "right";
        			vertSizing = "top";
        			position = "135 370";
        			extent = "115 36";
        			minExtent = "26 27";
        			visible = "1";
        			hideCursor = "0";
        			bypassHideCursor = "0";
        			variable = "$DemoPref::StartOnMatchStart";
				command = "DemoReminderSavePrefs();";
        			helpTag = "0";
        			text = "On Match Start";
        			longTextBuffer = "0";
        			maxLength = "255";
        		};
        		new ShellToggleButton(AutoStopOnEnd) {
        			profile = "ShellRadioProfile";
        			horizSizing = "right";
        			vertSizing = "top";
        			position = "250 370";
        			extent = "115 36";
        			minExtent = "26 27";
        			visible = "1";
        			hideCursor = "0";
        			bypassHideCursor = "0";
        			variable = "$DemoPref::AutoStopOnEnd";
				command = "DemoReminderSavePrefs();";
        			helpTag = "0";
        			text = "Auto Stop On End";
        			longTextBuffer = "0";
        			maxLength = "255";
        		};
        		new ShellToggleButton(ShowStatusHud) {
        			profile = "ShellRadioProfile";
        			horizSizing = "right";
        			vertSizing = "top";
        			position = "370 370";
        			extent = "115 36";
        			minExtent = "26 27";
        			visible = "1";
        			hideCursor = "0";
        			bypassHideCursor = "0";
        			variable = "$DemoPref::ShowStatusHud";
				command = "DemoReminderSavePrefs();";
        			helpTag = "0";
        			text = "Show Status Hud";
        			longTextBuffer = "0";
        			maxLength = "255";
        		};
       			new ShellToggleButton(demotransstatushud) {
       				profile = "ShellRadioProfile";
       				horizSizing = "right";
       				vertSizing = "top";
       				position = "485 370";
       				extent = "115 36";
       				minExtent = "26 27";
       				visible = "1";
       				hideCursor = "0";
       				bypassHideCursor = "0";
       				variable = "$DemoPref::demotransstatushud";
				command = "DemoReminderSavePrefs(); demotranshud();";
       				helpTag = "0";
       				text = "Transparent Status Hud";
       				longTextBuffer = "0";
       				maxLength = "255";
       			};
        	};
	        new ShellBitmapButton(Full_CloseButton)
	        {
	                profile = "CloseButtonProfile";
	                horizSizing = "left";
	                vertSizing = "bottom";
	                position = LaunchToolbarCloseButton.position;
	                extent = "33 26";
	                minExtent = "8 8";
	                visible = "1";
	                hideCursor = "0";
	                bypassHideCursor = "0";
	                setFirstResponder = "0";
	                modal = "1";
	                helpTag = "0";
	                command = "DemoReminderSavePrefs(); Canvas.popDialog(FullRecordingsDlg); $KmaDialogToggle = 0;";
	                text = "";
	                simpleStyle = "1";
	        };
	};
	DemoTimePopup.add("5", 0);
	DemoTimePopup.add("10", 1);
	DemoTimePopup.add("15", 2);
	DemoTimePopup.add("30", 3);
}

if (!isObject(DemoNameDlg))
{
	new GuiControl(DemoNameDlg) {
		profile = "DlgBackProfile";
		horizSizing = "width";
		vertSizing = "height";
		position = "0 0";
		extent = "640 480";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		new ShellDlgFrame(demonametitle) {
			profile = "ShellDlgProfile";
			horizSizing = "center";
			vertSizing = "center";
			position = "0 0";
			extent = "640 200";
			minExtent = "48 92";
			visible = "True";
			setFirstResponder = "False";
			modal = "True";
			helpTag = "0";
			text = "Demo Naming Scheme";
			hideCursor = "0";
			bypassHideCursor = "0";
			longTextBuffer = "0";
			maxLength = "255";
			new ShellTextEditCtrl(demonamestring) {
				profile = "NewTextEditProfile";
				horizSizing = "center";
				vertSizing = "top";
				position = "0 39";
				extent = "600 39";
				minExtent = "32 38";
				visible = "1";
				setFirstResponder = "true";
				hideCursor = "0";
				bypassHideCursor = "0";
        			variable = "$DemoPref::DemoName";
				command = "DemoReminderSavePrefs();";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				historySize = "0";
				password = "0";
				IRCName = "0";
				tabComplete = "0";
				deniedSound = "InputDeniedSound";
				glowOffset = "9 9";
			};
			new GuiMLTextCtrl(DemoName_Info) {
				profile = "GuiDefaultProfile";
				horizSizing = "center";
				vertSizing = "top";
				position = "0 80";
				extent = "580 100";
				minExtent = "580 100";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				lineSpacing = "2";
				allowColorChars = "1";
				maxChars = "-1";
				deniedSound = "InputDeniedSound";
			};
			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "right";
				vertSizing = "top";
				position = "30 150";
				extent = "125 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Load";
				simpleStyle = "0";
				command = "ShellGetLoadFilename( \"\", \"prefs/*.sch\", \"\", \"LoadScheme\" );";
			};
			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "right";
				vertSizing = "top";
				position = "180 150";
				extent = "125 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Save";
				simpleStyle = "0";
				command = "ShellGetSaveFilename( \"\", \"prefs/*.sch\", \"\", \"SaveScheme\" , $DemoPref::Scheme );";
			};
			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "right";
				vertSizing = "top";
				position = "330 150";
				extent = "125 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Delete";
				simpleStyle = "0";
				command = "messageBoxOkCancel(\"Delete Scheme?\", \"Are you sure you wish to delete '\"@$DemoPref::Scheme@\"'?\", \"DeleteScheme($DemoPref::Scheme);\");";
			};
			new ShellBitmapButton(DemoNameOKBtn) {
				profile = "ShellButtonProfile";
				horizSizing = "right";
				vertSizing = "top";
				position = "480 150";
				extent = "125 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "OK";
				simpleStyle = "0";
				command = "DemoReminderSavePrefs(); Canvas.popDialog(DemoNameDlg);";
			};
		};
	};
	DemoName_Info.setText("*mod* - Mod Name.  *map* - Map Name.  *ser* - Server Name.  *ip* - Server IP.  *gt* - GameType.  *pl* - Player Name." NL "*t1s* - Your Team Side.  *t1t* - Your Team Tag.  *t2s* - Enemy Team Side.  *t2t* - Enemy Team Tag.  *ts* - Team Size." NL "*day* - Two Digit Day.  *month* - Two Digit Month.  *year* - Two Digit Year." NL "You can use forward slashes with any of these to make Dirs.");
}

if (!isObject(DemoFindDlg))
{
	new GuiControl(DemoFindDlg) {
		profile = "GuiModelessDialogProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "640 480";
		minExtent = "8 8";
		visible = "1";
		helpTag = "0";
		new ShellWindowCtrl() {
			profile = "ShellWindowProfile";
			horizSizing = "center";
			vertSizing = "center";
			position = "0 0";
			extent = "245 155";
			minExtent = "245 155";
			visible = "1";
			helpTag = "0";
			text = "Demo Search";
			frameBase = "gui/window";
			borderWidth = "0";
			resizeWidth = "0";
			resizeHeight = "0";
			canMove = "1";
			canClose = "1";
			canMinimize = "0";
			canMaximize = "0";
			escapeCommand = "DemoReminderSavePrefs(); Canvas.popDialog(DemoFindDlg);";
			closeCommand = "DemoReminderSavePrefs(); Canvas.popDialog(DemoFindDlg);";
			new HudBitmapCtrl() {
				profile = "GuiContentProfile";
				horizSizing = "center";
				vertSizing = "height";
				position = "0 27";
				extent = "255 160";
				minextent = "255 160";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				fillColor = "0 0 0 255";
				frameColor = "0 0 0 255";
				new ShellFieldCtrl() {
					profile = "ShellFieldProfile";
					horizSizing = "center";
					vertSizing = "center";
					position = "0 0";
					extent = "245 155";
					minExtent = "245 155";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
					new ShellTextEditCtrl(SearchString) {
						profile = "NewTextEditProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "10 8";
						extent = "230 18";
						minExtent = "8 8";
						visible = "True";
						setFirstResponder = "true";
						modal = "True";
						altCommand = "FullRecordingsDlg.fillRecordingsList();";
						helpTag = "0";
						historySize = "0";
						fontHL = "14 253 Arial";
						font = "14 244 Arial";
					};
					new ShellBitmapButton() {
						profile = "ShellButtonProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "40 41";
						extent = "60 16";
						minExtent = "8 8";
						visible = "True";
						setFirstResponder = "False";
						modal = "True";
						command = "FullRecordingsDlg.fillRecordingsList();";
						helpTag = "0";
						text = "Search";
					};
					new ShellBitmapButton() {
						profile = "ShellButtonProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "150 41";
						extent = "60 16";
						minExtent = "8 8";
						visible = "True";
						setFirstResponder = "False";
						modal = "True";
						command = "DemoReminderSavePrefs(); Canvas.popDialog(DemoFindDlg);";
						helpTag = "0";
						text = "Close";
					};
					new ShellToggleButton(SearchName) {
						profile = "ShellRadioProfile";
			       			horizSizing = "right";
			       			vertSizing = "bottom";
						position = "5 73";
						extent = "115 36";
						minExtent = "26 27";
						visible = "1";
						hideCursor = "0";
						bypassHideCursor = "0";
						variable = "$DemoPref::SearchName";
						command = "DemoReminderSavePrefs();";
						helpTag = "0";
						text = "Search Name";
						longTextBuffer = "0";
						maxLength = "255";
					};
					new ShellToggleButton(SearchLength) {
						profile = "ShellRadioProfile";
			       			horizSizing = "right";
			       			vertSizing = "bottom";
						position = "122 73";
						extent = "115 36";
						minExtent = "26 27";
						visible = "1";
						hideCursor = "0";
						bypassHideCursor = "0";
						variable = "$DemoPref::SearchLength";
						command = "DemoReminderSavePrefs();";
						helpTag = "0";
						text = "Search Length";
						longTextBuffer = "0";
						maxLength = "255";
					};
					new ShellToggleButton(SearchDate) {
						profile = "ShellRadioProfile";
						horizSizing = "right";
			       			vertSizing = "bottom";
						position = "5 93";
						extent = "115 36";
						minExtent = "26 27";
						visible = "1";
						hideCursor = "0";
						bypassHideCursor = "0";
						variable = "$DemoPref::SearchDate";
						command = "DemoReminderSavePrefs();";
						helpTag = "0";
						text = "Search Date";
						longTextBuffer = "0";
						maxLength = "255";
					};
					new ShellToggleButton(SearchFolder) {
						profile = "ShellRadioProfile";
						horizSizing = "right";
			       			vertSizing = "bottom";
						position = "122 93";
						extent = "115 36";
						minExtent = "26 27";
						visible = "1";
						hideCursor = "0";
						bypassHideCursor = "0";
						variable = "$DemoPref::SearchFolder";
						command = "DemoReminderSavePrefs();";
						helpTag = "0";
						text = "Search Folder";
						longTextBuffer = "0";
						maxLength = "255";
					};
				};
			};
		};
	};
}

if(!isObject(KmaDemoReminderHUD))
{
	new GuiControlProfile("DemoReminderTextProfile")
	{
		fontType = "Univers Condensed";
		fontSize = 18;
		fontColor = "255 0 0";
		justify = "center";
	};
	new GuiTextCtrl(KmaDemoReminderHUD) {
		profile = "DemoReminderTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = getword($pref::Video::resolution, 0)/2-70 @ " " @ getword($pref::Video::resolution, 1)/4;
		extent = "140 26";
		minExtent = "8 8";
		visible = "0";
		helpTag = "0";
		text = "Start Recording Now!";
		maxLength = "255";
	};
	PlayGui.add(KmaDemoReminderHUD);
	if(isObject(HM) && isObject(HudMover)) hudmover::addhud(KmaDemoReminderHUD,"Demo Reminder");
}

if(!isObject(DemoStatusHud))
{
	new GuiControlProfile ("DemoStatusHudLabelProfile")
	{
		fontType = "Univers Condensed";
		fontSize = 16;
		fontColor = "255 255 64";
		justify = "center";
	};
	new GuiControlProfile ("DemoStatusHudTextProfile")
	{
		fontType = "Univers Condensed";
		fontSize = 16;
		fontColor = "255 0 0";
		justify = "center";
	};
	new ShellFieldCtrl(DemoStatusHud)
	{
		profile = "GuiChatBackProfile";
		horizSizing = "left";
		vertSizing = "bottom";
		extent = "55 16";
		minExtent = "8 8";
		visible = $DemoPref::ShowStatusHud;
		new GuiTextCtrl()
		{
			profile = "DemoStatusHudLabelProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "4 0";
			extent = "26 16 ";
			visible = "1";
			text = "Demo";
		};
		new GuiMLTextCtrl(DemoStatusHudtext) {
			profile = "DemoStatusHudTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "33 0";
			extent = "20 16 ";
			visible = "1";
		};
	};
	DemoStatusHud.profile = $DemoPref::demoTransStatusHud ? "GuiConsoleProfile" : "GuiChatBackProfile";
	playGui.add(DemoStatusHud);
	if(isObject(HM) && isObject(HudMover)) hudmover::addhud(DemoStatusHud,"Demo Status Hud");
}

function demotranshud()
{
	DemoStatusHud.profile = $DemoPref::demoTransStatusHud ? "GuiConsoleProfile" : "GuiChatBackProfile";
}

function FullRecordingsDlg::onClose(%this, %key){}
function FullRecordingsDlg::setKey(%this, %key){}
